/*!
 * MediaElement.js
 * http://www.mediaelementjs.com/
 *
 * Wrapper that mimics native HTML5 MediaElement (audio and video)
 * using a variety of technologies (pure JavaScript, Flash, iframe)
 *
 * Copyright 2010-2017, John Dyer (http://j.hn/)
 * License: MIT
 *
 */
!function r(s,o,d){function l(e,t){if(!o[e]){if(!s[e]){var a="function"==typeof require&&require;if(!t&&a)return a(e,!0);if(g)return g(e,!0);var i=new Error("Cannot find module '"+e+"'");throw i.code="MODULE_NOT_FOUND",i}var n=o[e]={exports:{}};s[e][0].call(n.exports,function(t){return l(s[e][1][t]||t)},n,n.exports,r,s,o,d)}return o[e].exports}for(var g="function"==typeof require&&require,t=0;t<d.length;t++)l(d[t]);return l}({1:[function(t,e,a){"use strict";Object.assign(mejs.MepDefaults,{vastAdTagUrl:"",vastAdsType:"vast"}),Object.assign(MediaElementPlayer.prototype,{vastAdTagIsLoading:!1,vastAdTagIsLoaded:!1,vastStartedPlaying:!1,vastAdTags:[],buildvast:function(t,e,a,i){var n=this;n.isVideo&&(""!==n.options.vastAdTagUrl&&n.vastLoadAdTagInfo(),n.buildads(t,e,a,i),n.vastSetupEvents())},vastSetupEvents:function(){var p=this,h=!1,u=!1,f=!1;p.container.addEventListener("mejsprerollinitialized",function(){if(0<p.vastAdTags.length){var t=p.vastAdTags[0];if(t.trackingEvents.initialization)for(var e=0,a=t.trackingEvents.initialization.length;e<a;e++)p.adsLoadUrl(t.trackingEvents.initialization[e])}}),p.container.addEventListener("mejsprerollstarted",function(){if(0<p.vastAdTags.length){var t=p.vastAdTags[0];if(t.trackingEvents.start)for(var e=0,a=t.trackingEvents.start.length;e<a;e++)p.adsLoadUrl(t.trackingEvents.start[e]);if(!t.shown&&0<t.impressions.length)for(var i=0,n=t.impressions.length;i<n;i++)p.adsLoadUrl(t.impressions[i]);t.shown=!0}}),p.container.addEventListener("mejsprerollvolumechanged",function(){if(0<p.vastAdTags.length&&p.options.indexPreroll<p.vastAdTags.length){var t=p.vastAdTags[p.options.indexPreroll];if(t.trackingEvents.mute&&!p.media.volume)for(var e=0,a=t.trackingEvents.mute.length;e<a;e++)p.adsLoadUrl(t.trackingEvents.mute[e]);if(t.trackingEvents.unmute&&p.media.volume)for(var i=0,n=t.trackingEvents.unmute.length;i<n;i++)p.adsLoadUrl(t.trackingEvents.unmute[i])}}),p.container.addEventListener("mejsprerolltimeupdate",function(t){if(0<p.vastAdTags.length&&p.options.indexPreroll<p.vastAdTags.length){var e=t.detail.duration,a=t.detail.currentTime,i=100*Math.min(1,Math.max(0,a/e)),n=p.vastAdTags[p.options.indexPreroll],r=25<=i&&i<50,s=50<=i&&i<75,o=75<=i&&i<100;if(n.trackingEvents.firstQuartile&&!h&&r){for(var d=0,l=n.trackingEvents.firstQuartile.length;d<l;d++)p.adsLoadUrl(n.trackingEvents.firstQuartile[d]);h=!0}else if(n.trackingEvents.midpoint&&!u&&s){for(var g=0,v=n.trackingEvents.midpoint.length;g<v;g++)p.adsLoadUrl(n.trackingEvents.midpoint[g]);u=!0}else if(n.trackingEvents.thirdQuartile&&!f&&o){for(var c=0,m=n.trackingEvents.thirdQuartile.length;c<m;c++)p.adsLoadUrl(n.trackingEvents.thirdQuartile[c]);f=!0}}}),p.container.addEventListener("mejsprerollended",function(){var t=p.vastAdTags[p.options.indexPreroll];if(0<p.vastAdTags.length&&p.options.indexPreroll<p.vastAdTags.length&&t.trackingEvents.complete)for(var e=0,a=t.trackingEvents.complete.length;e<a;e++)p.adsLoadUrl(t.trackingEvents.complete[e]);f=u=h=!1}),p.container.addEventListener("mejsprerolladsclicked",function(){var t=p.vastAdTags[p.options.indexPreroll];0<p.vastAdTags.length&&p.options.indexPreroll<p.vastAdTags.length&&t.clickThrough&&t.clickTracking&&p.adsLoadUrl(t.clickTracking)}),p.container.addEventListener("mejsprerollskipclicked",function(){var t=p.vastAdTags[p.options.indexPreroll];if(0<p.vastAdTags.length&&p.options.indexPreroll<p.vastAdTags.length&&t.trackingEvents.skip)for(var e=0,a=t.trackingEvents.skip.length;e<a;e++)p.adsLoadUrl(t.trackingEvents.skip[e])})},vastSetAdTagUrl:function(t){this.options.vastAdTagUrl=t,this.options.indexPreroll=0,this.vastAdTagIsLoaded=!1,this.vastAdTags=[]},vastLoadAdTagInfo:function(){this.adsDataIsLoading=!0,this.vastAdTagIsLoading=!0,this.loadAdTagInfoDirect()},loadAdTagInfoDirect:function(){var e=this;mejs.Utils.ajax(e.options.vastAdTagUrl,"xml",function(t){"vpaid"===e.options.vastAdsType?e.vpaidParseVpaidData(t):e.vastParseVastData(t)},function(t){console.error("vast3:direct:error",t),e.loadAdTagInfoProxy()})},loadAdTagInfoProxy:function(){var e=this,t=location.protocol,a='select * from xml where url="'+encodeURI(e.options.vastAdTagUrl)+'"',i="http"+(/^https/.test(t)?"s":"")+"://query.yahooapis.com/v1/public/yql?format=xml&q="+a;mejs.Utils.ajax(i,"xml",function(t){"vpaid"===e.options.vastAdsType?e.vpaidParseVpaidData(t):e.vastParseVastData(t)},function(t){console.error("vast:proxy:yahoo:error",t)})},vastParseVastData:function(t){var e=this,a=t.getElementsByTagName("Ad");if(a.length){e.vastAdTags=[];for(var i=e.options.indexPreroll=0,n=a.length;i<n;i++){var r=a[i],s=r.getElementsByTagName("AdTitle").length?r.getElementsByTagName("AdTitle")[0].textContent.trim():"",o=r.getElementsByTagName("Description").length?r.getElementsByTagName("Description")[0].textContent.trim():"",d=r.getElementsByTagName("ClickThrough").length?r.getElementsByTagName("ClickThrough")[0].textContent.trim():"",l=r.getElementsByTagName("ClickTracking").length?r.getElementsByTagName("ClickTracking")[0].textContent.trim():"",g={id:r.getAttribute("id"),title:s,description:o,impressions:[],clickThrough:d,clickTracking:l,mediaFiles:[],trackingEvents:{},shown:!1},v=r.getElementsByTagName("Impression"),c=r.getElementsByTagName("MediaFile"),m=r.getElementsByTagName("Tracking");e.vastAdTags.push(g);for(var p=0,h=v.length;p<h;p++)g.impressions.push(v[p].textContent.trim());for(var u=0,f=m.length;u<f;u++){var T=m[u],A=T.getAttribute("event");void 0===g.trackingEvents[A]&&(g.trackingEvents[A]=[]),g.trackingEvents[A].push(T.textContent.trim())}for(var k=0,E=c.length;k<E;k++){var y=c[k],x=y.getAttribute("type");if(""!==e.media.canPlayType(x)||/(no|false)/i.test(e.media.canPlayType(x)))if("application/javascript"===x){var P=document.createElement("script"),L=document.getElementsByTagName("script")[0];P.src=y.textContent.trim(),L.parentNode.insertBefore(P,L)}else"application/x-shockwave-flash"!==x&&g.mediaFiles.push({id:y.getAttribute("id"),delivery:y.getAttribute("delivery"),type:x,bitrate:y.getAttribute("bitrate"),width:y.getAttribute("width"),height:y.getAttribute("height"),url:y.textContent.trim()})}}e.vastLoaded()}},vpaidParseVpaidData:function(t){var e=this,a=t.getElementsByTagName("AdParameters");if(e.vpaidAdTags=[],void(e.options.indexPreroll=0)!==a[0]){var i=JSON.parse(a[0].textContent.trim()),n=t.getElementsByTagName("Duration"),r={id:i.ad_id.trim(),title:i.title.trim(),clickThrough:i.page_url,impressions:[],mediaFiles:[],trackingEvents:{},shown:!1};if(void 0!==i.media.tracking.beacon)for(var s=["initialization","start","firstQuartile","midpoint","thirdQuartile","complete"],o=0,d=i.media.tracking.beacon.length;o<d;o++){var l=i.media.tracking.beacon[o];~s.indexOf(l.type)?(void 0===r.trackingEvents[l.type]&&(r.trackingEvents[l.type]=[]),r.trackingEvents[l.type].push(l.beacon_url.trim())):"impression"===l.type&&r.impressions.push(l.beacon_url.trim())}for(var g in i.media.video)if(i.media.video.hasOwnProperty(g)){var v=i.media.video[g],c=v.mime_type.trim();(""!==e.media.canPlayType(c)||/(no|false)/i.test(e.media.canPlayType(c)))&&r.mediaFiles.push({id:v.media_id,format:v.format,type:c,transcoding:v.transcoding,width:v.width,height:v.height,duration:n,url:v.media_url})}e.vastAdTags.push(r),e.vastLoaded()}},vastLoaded:function(){this.vastAdTagIsLoaded=!0,this.vastAdTagIsLoading=!1,this.adsDataIsLoading=!1,this.vastStartPreroll()},vastStartPreroll:function(){for(var t=this,e=0;e<t.vastAdTags.length;)void 0!==t.vastAdTags[e].mediaFiles&&t.vastAdTags[e].mediaFiles.length&&(t.options.adsPrerollMediaUrl[e]=t.vastAdTags[e].mediaFiles[0].url),void 0!==t.vastAdTags[e].clickThrough&&(t.options.adsPrerollAdUrl[e]=t.vastAdTags[e].clickThrough),e++;t.adsStartPreroll()}})},{}]},{},[1]);