/*!
 * MediaElement.js
 * http://www.mediaelementjs.com/
 *
 * Wrapper that mimics native HTML5 MediaElement (audio and video)
 * using a variety of technologies (pure JavaScript, Flash, iframe)
 *
 * Copyright 2010-2017, John Dyer (http://j.hn/)
 * License: MIT
 *
 */
!function s(o,n,c){function l(t,e){if(!n[t]){if(!o[t]){var a="function"==typeof require&&require;if(!e&&a)return a(t,!0);if(d)return d(t,!0);var r=new Error("Cannot find module '"+t+"'");throw r.code="MODULE_NOT_FOUND",r}var i=n[t]={exports:{}};o[t][0].call(i.exports,function(e){return l(o[t][1][e]||e)},i,i.exports,s,o,n,c)}return n[t].exports}for(var d="function"==typeof require&&require,e=0;e<c.length;e++)l(c[e]);return l}({1:[function(e,t,a){"use strict";var r,i=e(2),o=(r=i)&&r.__esModule?r:{default:r};mejs.i18n.en["mejs.chromecast-legend"]="Casting to:",Object.assign(mejs.MepDefaults,{castTitle:null,castAppID:null,castPolicy:"origin",castEnableTracks:!1,castIsLive:!1}),Object.assign(MediaElementPlayer.prototype,{buildchromecast:function(a,e,t,r){var i=this,s=document.createElement("div"),o=mejs.Utils.isString(i.options.castTitle)?i.options.castTitle:"Chromecast";if(a.chromecastLayer=document.createElement("div"),a.chromecastLayer.className=i.options.classPrefix+"chromecast-layer "+i.options.classPrefix+"layer",a.chromecastLayer.innerHTML='<div class="'+i.options.classPrefix+'chromecast-info"></div>',a.chromecastLayer.style.display="none",t.insertBefore(a.chromecastLayer,t.firstChild),s.className=i.options.classPrefix+"button "+i.options.classPrefix+"chromecast-button",s.innerHTML='<button type="button" is="google-cast-button" aria-controls="'+i.id+'" title="'+o+'" aria-label="'+o+'" tabindex="0"></button>',s.style.display="none",i.addControlElement(s,"chromecast"),i.castButton=s,a.chromecastLayer.innerHTML='<div class="'+i.options.classPrefix+'chromecast-container"><span class="'+i.options.classPrefix+'chromecast-icon"></span><span class="'+i.options.classPrefix+'chromecast-info">'+mejs.i18n.t("mejs.chromecast-legend")+' <span class="device"></span></span></div>',r.originalNode.getAttribute("poster")&&(a.chromecastLayer.innerHTML+='<img src="'+r.originalNode.getAttribute("poster")+'" width="100%" height="100%">',a.chromecastLayer.querySelector("img").addEventListener("click",function(){if(a.options.clickToPlayPause){var e=i.container.querySelector("."+i.options.classPrefix+"overlay-button"),t=e.getAttribute("aria-pressed");a.paused?a.play():a.pause(),e.setAttribute("aria-pressed",!!t),a.container.focus()}})),window.__onGCastApiAvailable=function(e){var t=mejs.Utils.getTypeFromFile(r.originalNode.src).toLowerCase(),a=t&&-1<["application/x-mpegurl","application/vnd.apple.mpegurl","application/dash+xml","video/mp4","audio/mp3","audio/mp4"].indexOf(t);e&&a&&i._initializeCastPlayer()},window.cast){var n=i.controls.querySelector("."+i.options.classPrefix+"chromecast-button>button");return n&&"none"!==n.style.display&&(i.controls.querySelector("."+i.options.classPrefix+"chromecast-button").style.display=""),void i._initializeCastPlayer()}mejs.Utils.loadScript("https://www.gstatic.com/cv/js/sender/v1/cast_sender.js?loadCastFramework=1")},cleanchromecast:function(e){if(window.cast){var t=cast.framework.CastContext.getInstance().getCurrentSession();t&&t.endSession(!0)}e.castButton&&e.castButton.remove(),e.chromecastLayer&&e.chromecastLayer.remove()},_initializeCastPlayer:function(){var e=this,t=void 0;switch(this.options.castPolicy){case"tab":t="TAB_AND_ORIGIN_SCOPED";break;case"page":t="PAGE_SCOPED";break;default:t="ORIGIN_SCOPED"}var a=cast.framework.CastContext.getInstance(),r=a.getCurrentSession();if(a.setOptions({receiverApplicationId:e.options.castAppID||chrome.cast.media.DEFAULT_MEDIA_RECEIVER_APP_ID,autoJoinPolicy:chrome.cast.AutoJoinPolicy[t]}),a.addEventListener(cast.framework.CastContextEventType.CAST_STATE_CHANGED,e._checkCastButtonStatus.bind(e)),e.remotePlayer=new cast.framework.RemotePlayer,e.remotePlayerController=new cast.framework.RemotePlayerController(e.remotePlayer),e.remotePlayerController.addEventListener(cast.framework.RemotePlayerEventType.IS_CONNECTED_CHANGED,e._switchToCastPlayer.bind(this)),r){var i=a.getCastState(),s=e.controls.querySelector("."+e.options.classPrefix+"chromecast-button");s&&i===cast.framework.CastState.NO_DEVICES_AVAILABLE?s.style.display="none":s&&(e.chromecastLayer&&(e.chromecastLayer.style.display=i===cast.framework.CastState.CONNECTED?"":"none"),s.style.display=""),e._switchToCastPlayer()}},_checkCastButtonStatus:function(e){var t=this,a=t.controls.querySelector("."+t.options.classPrefix+"chromecast-button");a&&e.castState===cast.framework.CastState.NO_DEVICES_AVAILABLE?a.style.display="none":a&&(t.chromecastLayer&&(t.chromecastLayer.style.display=e.castState===cast.framework.CastState.CONNECTED?"":"none"),a.style.display=""),setTimeout(function(){t.setPlayerSize(t.width,t.height),t.setControlsSize()},0)},_switchToCastPlayer:function(){var e=this;if((e.proxy&&e.proxy.pause(),cast&&cast.framework)&&(cast.framework.CastContext.getInstance().addEventListener(cast.framework.CastContextEventType.CAST_STATE_CHANGED,e._checkCastButtonStatus.bind(e)),e.remotePlayer.isConnected))return void e._setupCastPlayer();e._setDefaultPlayer()},_setupCastPlayer:function(){var r=this,s=cast.framework.CastContext.getInstance().getCurrentSession(),e=r.layers.querySelector("."+r.options.classPrefix+"chromecast-info");!0!==r.loadedChromecast&&(r.loadedChromecast=!0,r.proxy=new o.default(r.remotePlayer,r.remotePlayerController,r.media,r.options),e&&(e.querySelector(".device").innerText=s.getCastDevice().friendlyName),r.chromecastLayer&&(r.chromecastLayer.style.display=""),!0===r.options.castEnableTracks&&function(){var i=void 0!==r.captionsButton?r.captionsButton.querySelectorAll("input[type=radio]"):null;if(null!==i)for(var e=function(r,e){i[r].addEventListener("click",function(){var e=parseInt(i[r].id.replace(/^.*?track_(\d+)_.*$/,"$1")),t="none"===i[r].value?[]:[e],a=new chrome.cast.media.EditTracksInfoRequest(t);s.getMediaSession().editTracksInfo(a,function(){},function(e){console.error(e)})})},t=0,a=i.length;t<a;t++)e(t)}(),r.media.addEventListener("loadedmetadata",function(){-1===["SESSION_ENDING","SESSION_ENDED","NO_SESSION"].indexOf(s.getSessionState())&&r.proxy instanceof DefaultPlayer&&(r.proxy.pause(),r.proxy=new o.default(r.remotePlayer,r.remotePlayerController,r.media,r.options))}),r.media.addEventListener("timeupdate",function(){r.currentMediaTime=r.getCurrentTime()}))}})},{2:2}],2:[function(e,t,a){"use strict";Object.defineProperty(a,"__esModule",{value:!0});var r=function(){function r(e,t){for(var a=0;a<t.length;a++){var r=t[a];r.enumerable=r.enumerable||!1,r.configurable=!0,"value"in r&&(r.writable=!0),Object.defineProperty(e,r.key,r)}}return function(e,t,a){return t&&r(e.prototype,t),a&&r(e,a),e}}();var i=function(){function s(e,t,a,r){!function(e,t){if(!(e instanceof t))throw new TypeError("Cannot call a class as a function")}(this,s);var i=this;return i.player=e,i.controller=t,i.media=a,i.endedMedia=!1,i.enableTracks=r.castEnableTracks,i.isLive=r.castIsLive,i.controller.addEventListener(cast.framework.RemotePlayerEventType.IS_PAUSED_CHANGED,function(){i.paused?i.pause():i.play(),i.endedMedia=!1}),i.controller.addEventListener(cast.framework.RemotePlayerEventType.IS_MUTED_CHANGED,function(){i.setMuted(i.player.isMuted),i.volume=0}),i.controller.addEventListener(cast.framework.RemotePlayerEventType.IS_MEDIA_LOADED_CHANGED,function(){var e=mejs.Utils.createEvent("loadedmetadata",i.media);i.media.dispatchEvent(e)}),i.controller.addEventListener(cast.framework.RemotePlayerEventType.VOLUME_LEVEL_CHANGED,function(){i.volume=i.player.volumeLevel;var e=mejs.Utils.createEvent("volumechange",i.media);i.media.dispatchEvent(e)}),i.controller.addEventListener(cast.framework.RemotePlayerEventType.DURATION_CHANGED,function(){var e=mejs.Utils.createEvent("timeupdate",i.media);i.media.dispatchEvent(e)}),i.controller.addEventListener(cast.framework.RemotePlayerEventType.CURRENT_TIME_CHANGED,function(){var e=mejs.Utils.createEvent("timeupdate",i.media);i.media.dispatchEvent(e),!i.isLive&&i.getCurrentTime()>=i.getDuration()&&(i.endedMedia=!0,setTimeout(function(){var e=mejs.Utils.createEvent("ended",i.media);i.media.dispatchEvent(e)},50))}),i.controller.addEventListener(cast.framework.RemotePlayerEventType.IS_MUTED_CHANGED,function(){i.setMuted(i.player.isMuted)}),i.load(),i}return r(s,[{key:"getSrc",value:function(){return this.media.originalNode.src}},{key:"setSrc",value:function(e){this.media.originalNode.src="string"==typeof e?e:e[0].src,this.load()}},{key:"setCurrentTime",value:function(e){this.player.currentTime=e,this.controller.seek();var t=mejs.Utils.createEvent("timeupdate",this.media);this.media.dispatchEvent(t)}},{key:"getCurrentTime",value:function(){return this.player.currentTime}},{key:"getDuration",value:function(){return this.player.duration}},{key:"setVolume",value:function(e){this.player.volumeLevel=e,this.controller.setVolumeLevel();var t=mejs.Utils.createEvent("volumechange",this.media);this.media.dispatchEvent(t)}},{key:"getVolume",value:function(){return this.player.volumeLevel}},{key:"play",value:function(){if(this.player.isPaused){this.controller.playOrPause();var e=mejs.Utils.createEvent("play",this.media);this.media.dispatchEvent(e)}}},{key:"pause",value:function(){if(!this.player.isPaused){this.controller.playOrPause();var e=mejs.Utils.createEvent("pause",this.media);this.media.dispatchEvent(e)}}},{key:"load",value:function(){var a=this,e=this.media.originalNode.src,t=mejs.Utils.getTypeFromFile(e),r=new chrome.cast.media.MediaInfo(e,t),i=cast.framework.CastContext.getInstance().getCurrentSession();if(e!==window.location.href&&i){if(!0===a.enableTracks){for(var s=[],o=a.media.originalNode.children,n=1,c=0,l=o.length;c<l;c++){var d=o[c];if("track"===d.tagName.toLowerCase()&&("subtitles"===d.getAttribute("kind")||"captions"===d.getAttribute("kind"))){var u=new chrome.cast.media.Track(n,chrome.cast.media.TrackType.TEXT);u.trackContentId=mejs.Utils.absolutizeUrl(d.getAttribute("src")),u.trackContentType="text/vtt",u.subtype=chrome.cast.media.TextTrackType.SUBTITLES,u.name=d.getAttribute("label"),u.language=d.getAttribute("srclang"),u.customData=null,s.push(u),n++}}r.textTrackStyle=new chrome.cast.media.TextTrackStyle,r.tracks=s}if(r.metadata=new chrome.cast.media.GenericMediaMetadata,r.streamType=a.isLive?chrome.cast.media.StreamType.LIVE:chrome.cast.media.StreamType.BUFFERED,r.customData=null,r.duration=null,r.currentTime=a.isLive?1/0:0,a.media.originalNode.getAttribute("data-cast-title")&&(r.metadata.title=a.media.originalNode.getAttribute("data-cast-title")),a.media.originalNode.getAttribute("data-cast-description")&&(r.metadata.subtitle=a.media.originalNode.getAttribute("data-cast-description")),a.media.originalNode.getAttribute("poster")||a.media.originalNode.getAttribute("data-cast-poster")){var m=a.media.originalNode.getAttribute("poster")||a.media.originalNode.getAttribute("data-cast-poster");r.metadata.images=[{url:mejs.Utils.absolutizeUrl(m)}]}var p=new chrome.cast.media.LoadRequest(r);i.loadMedia(p).then(function(){var e=a.media.originalNode.currentTime;a.setCurrentTime(e),a.play();var t=mejs.Utils.createEvent("play",a.media);a.media.dispatchEvent(t)},function(e){a._getErrorMessage(e)})}}},{key:"setMuted",value:function(e){var t=this;!0!==e||this.player.isMuted?!1===e&&this.player.isMuted&&this.controller.muteOrUnmute():this.controller.muteOrUnmute(),setTimeout(function(){var e=mejs.Utils.createEvent("volumechange",t.media);t.media.dispatchEvent(e)},50)}},{key:"canPlayType",value:function(e){return~["application/x-mpegurl","vnd.apple.mpegurl","application/dash+xml","video/mp4"].indexOf(e)}},{key:"_getErrorMessage",value:function(e){var t=e.description?" : "+e.description:".",a=void 0;switch(e.code){case chrome.cast.ErrorCode.API_NOT_INITIALIZED:a="The API is not initialized"+t;break;case chrome.cast.ErrorCode.CANCEL:a="The operation was canceled by the user"+t;break;case chrome.cast.ErrorCode.CHANNEL_ERROR:a="A channel to the receiver is not available"+t;break;case chrome.cast.ErrorCode.EXTENSION_MISSING:a="The Cast extension is not available"+t;break;case chrome.cast.ErrorCode.INVALID_PARAMETER:a="The parameters to the operation were not valid"+t;break;case chrome.cast.ErrorCode.RECEIVER_UNAVAILABLE:a="No receiver was compatible with the session request"+t;break;case chrome.cast.ErrorCode.SESSION_ERROR:a="A session could not be created, or a session was invalid"+t;break;case chrome.cast.ErrorCode.TIMEOUT:a="The operation timed out"+t;break;default:a="Unknown error: "+e}console.error(a)}},{key:"paused",get:function(){return this.player.isPaused}},{key:"muted",set:function(e){this.setMuted(e)},get:function(){return this.player.isMuted}},{key:"ended",get:function(){return this.endedMedia}},{key:"readyState",get:function(){return this.media.originalNode.readyState}},{key:"currentTime",set:function(e){this.setCurrentTime(e)},get:function(){return this.getCurrentTime()}},{key:"duration",get:function(){return this.getDuration()}},{key:"volume",set:function(e){this.setVolume(e)},get:function(){return this.getVolume()}},{key:"src",set:function(e){this.setSrc(e)},get:function(){return this.getSrc()}}]),s}();a.default=i,window.ChromecastPlayer=i},{}]},{},[1,2]);