/*!
 * MediaElement.js
 * http://www.mediaelementjs.com/
 *
 * Wrapper that mimics native HTML5 MediaElement (audio and video)
 * using a variety of technologies (pure JavaScript, Flash, iframe)
 *
 * Copyright 2010-2017, John Dyer (http://j.hn/)
 * License: MIT
 *
 */
!function c(i,u,n){function a(o,e){if(!u[o]){if(!i[o]){var t="function"==typeof require&&require;if(!e&&t)return t(o,!0);if(l)return l(o,!0);var r=new Error("Cannot find module '"+o+"'");throw r.code="MODULE_NOT_FOUND",r}var s=u[o]={exports:{}};i[o][0].call(s.exports,function(e){return a(i[o][1][e]||e)},s,s.exports,c,i,u,n)}return u[o].exports}for(var l="function"==typeof require&&require,e=0;e<n.length;e++)a(n[e]);return a}({1:[function(e,o,t){"use strict";mejs.i18n.en["mejs.source-chooser"]="Source Chooser",Object.assign(mejs.MepDefaults,{sourcechooserText:null}),Object.assign(MediaElementPlayer.prototype,{buildsourcechooser:function(o,e,t,i){for(var u=this,r=mejs.Utils.isString(u.options.sourcechooserText)?u.options.sourcechooserText:mejs.i18n.t("mejs.source-chooser"),s=[],c=u.mediaFiles?u.mediaFiles:u.node.children,n=void 0,a=0,l=c.length;a<l;a++){var h=c[a];u.mediaFiles?s.push(h):"SOURCE"===h.nodeName&&s.push(h)}if(!(s.length<=1)){o.sourcechooserButton=document.createElement("div"),o.sourcechooserButton.className=u.options.classPrefix+"button "+u.options.classPrefix+"sourcechooser-button",o.sourcechooserButton.innerHTML='<button type="button" role="button" aria-haspopup="true" aria-owns="'+u.id+'" title="'+r+'" aria-label="'+r+'" tabindex="0"></button><div class="'+u.options.classPrefix+"sourcechooser-selector "+u.options.classPrefix+'offscreen" role="menu" aria-expanded="false" aria-hidden="true"><ul></ul></div>',u.addControlElement(o.sourcechooserButton,"sourcechooser");for(var d=0,f=s.length;d<f;d++){var p=s[d];void 0!==p.type&&"function"==typeof i.canPlayType&&o.addSourceButton(p.src,p.title,p.type,i.src===p.src)}o.sourcechooserButton.addEventListener("mouseover",function(){clearTimeout(n),o.showSourcechooserSelector()}),o.sourcechooserButton.addEventListener("mouseout",function(){n=setTimeout(function(){o.hideSourcechooserSelector()},0)}),o.sourcechooserButton.addEventListener("keydown",function(e){if(u.options.keyActions.length){switch(e.which||e.keyCode||0){case 32:mejs.MediaFeatures.isFirefox||o.showSourcechooserSelector(),o.sourcechooserButton.querySelector("input[type=radio]:checked").focus();break;case 13:o.showSourcechooserSelector(),o.sourcechooserButton.querySelector("input[type=radio]:checked").focus();break;case 27:o.hideSourcechooserSelector(),o.sourcechooserButton.querySelector("button").focus();break;default:return!0}e.preventDefault(),e.stopPropagation()}}),o.sourcechooserButton.addEventListener("focusout",mejs.Utils.debounce(function(){setTimeout(function(){document.activeElement.closest("."+u.options.classPrefix+"sourcechooser-selector")||o.hideSourcechooserSelector()},0)},100));for(var S=o.sourcechooserButton.querySelectorAll("input[type=radio]"),v=0,y=S.length;v<y;v++)S[v].addEventListener("click",function(){this.setAttribute("aria-selected",!0),this.checked=!0;for(var e=this.closest("."+u.options.classPrefix+"sourcechooser-selector").querySelectorAll("input[type=radio]"),o=0,t=e.length;o<t;o++)e[o]!==this&&(e[o].setAttribute("aria-selected","false"),e[o].removeAttribute("checked"));var r=this.value;if(i.getSrc()!==r){var s=i.currentTime,c=i.paused;i.pause(),i.setSrc(r),i.load(),i.addEventListener("canplay",function e(){c||(i.setCurrentTime(s),i.play()),i.removeEventListener("canplay",e)})}});o.sourcechooserButton.querySelector("button").addEventListener("click",function(){mejs.Utils.hasClass(mejs.Utils.siblings(this,"."+u.options.classPrefix+"sourcechooser-selector"),u.options.classPrefix+"offscreen")?(o.showSourcechooserSelector(),o.sourcechooserButton.querySelector("input[type=radio]:checked").focus()):o.hideSourcechooserSelector()})}},addSourceButton:function(e,o,t,r){var s=this;""!==o&&void 0!==o||(o=e),t=t.split("/")[1],s.sourcechooserButton.querySelector("ul").innerHTML+='<li><input type="radio" name="'+s.id+'_sourcechooser" id="'+s.id+"_sourcechooser_"+o+t+'" role="menuitemradio" value="'+e+'" '+(r?'checked="checked"':"")+' aria-selected="'+r+'"/><label for="'+s.id+"_sourcechooser_"+o+t+'" aria-hidden="true">'+o+" ("+t+")</label></li>",s.adjustSourcechooserBox()},adjustSourcechooserBox:function(){this.sourcechooserButton.querySelector("."+this.options.classPrefix+"sourcechooser-selector").style.height=parseFloat(this.sourcechooserButton.querySelector("."+this.options.classPrefix+"sourcechooser-selector ul").offsetHeight)+"px"},hideSourcechooserSelector:function(){var e=this;if(void 0!==e.sourcechooserButton&&e.sourcechooserButton.querySelector("input[type=radio]")){var o=e.sourcechooserButton.querySelector("."+e.options.classPrefix+"sourcechooser-selector"),t=o.querySelectorAll("input[type=radio]");o.setAttribute("aria-expanded","false"),o.setAttribute("aria-hidden","true"),mejs.Utils.addClass(o,e.options.classPrefix+"offscreen");for(var r=0,s=t.length;r<s;r++)t[r].setAttribute("tabindex","-1")}},showSourcechooserSelector:function(){var e=this;if(void 0!==e.sourcechooserButton&&e.sourcechooserButton.querySelector("input[type=radio]")){var o=e.sourcechooserButton.querySelector("."+e.options.classPrefix+"sourcechooser-selector"),t=o.querySelectorAll("input[type=radio]");o.setAttribute("aria-expanded","true"),o.setAttribute("aria-hidden","false"),mejs.Utils.removeClass(o,e.options.classPrefix+"offscreen");for(var r=0,s=t.length;r<s;r++)t[r].setAttribute("tabindex","0")}}})},{}]},{},[1]);